#pragma once

/********************************

Class:   CVertexBufferObject

Purpose: Wraps OpenGL vertex buffer
         object.

********************************/

class CVertexBufferObject
{
public:
	void CreateVBO(int a_iSize = 0);
	void ReleaseVBO();

	void BindVBO(int a_iBufferType = GL_ARRAY_BUFFER);
	void UploadDataToGPU(int iUsageHint);

	void AddData(void* ptrData, UINT uiDataSize);

	CVertexBufferObject();

private:
	UINT uiBuffer;
	int iSize;
	int iBufferType;
	std::vector<BYTE> data;

	bool bDataUploaded;
};
