#pragma once

#include <ft2build.h>
#include FT_FREETYPE_H

#include "Texture.h"
#include "Shaders.h"
#include "VertexBufferObject.h"

/********************************

Class:   CFreeTypeFont

Purpose: Wraps FreeType fonts and
         their usage with OpenGL.

********************************/

class CFreeTypeFont
{
public:
	bool LoadFont(std::string sFile, int iPXSize);

	int GetTextWidth(std::string sText, int iPXSize);

	void print(std::string sText, int x, int y, int iPXSize = -1);

	void ReleaseFont();

	void SetShaderProgram(CShaderProgram* a_shShaderProgram);

	CFreeTypeFont();
private:
	void CreateChar(int iIndex);

	CTexture tCharTextures[256];
	int iAdvX[256], iAdvY[256];
	int iBearingX[256], iBearingY[256];
	int iCharWidth[256], iCharHeight[256];
	int iLoadedPixelSize, iNewLine;

	bool bLoaded;

	UINT uiVAO;
	CVertexBufferObject vboData;

	FT_Library ftLib;
	FT_Face ftFace;
	CShaderProgram* shShaderProgram;
};
