#pragma once

/********************************

Class:   CFlyingCamera

Purpose: Camera that can fly
         around the scene.

********************************/

class CFlyingCamera
{
public:
	glm::vec3 vEye, vView, vUp;
	float fSpeed;
	float fSensitivity; // How many degrees to rotate per pixel moved by mouse (nice value is 0.10)

	// Main functions
	void RotateWithMouse(float deltaX, float deltaY);
	void update();
	glm::mat4 look();

	void SetMovingKeys(int a_iForw, int a_iBack, int a_iLeft, int a_iRight);

	// Functions that get viewing angles
	float GetAngleX(), GetAngleY();

	// Constructors
	CFlyingCamera();
	CFlyingCamera(glm::vec3 a_vEye, glm::vec3 a_vView, glm::vec3 a_vUp, float a_fSpeed, float a_fSensitivity);

private:
	int iForw, iBack, iLeft, iRight;
};

extern CFlyingCamera fcMain;
